summaryrefslogtreecommitdiffstats
path: root/modules.d/95dasd_rules/module-setup.sh
diff options
context:
space:
mode:
authorDaniel Baumann <daniel.baumann@progress-linux.org>2024-06-03 13:54:25 +0000
committerDaniel Baumann <daniel.baumann@progress-linux.org>2024-06-03 13:54:25 +0000
commit9cb1c4df7b9ce1a9ad1312621b0f2b16a94fba3a (patch)
tree2efb72864cc69e174c9c5ee33efb88a5f1553b48 /modules.d/95dasd_rules/module-setup.sh
parentInitial commit. (diff)
downloaddracut-9cb1c4df7b9ce1a9ad1312621b0f2b16a94fba3a.tar.xz
dracut-9cb1c4df7b9ce1a9ad1312621b0f2b16a94fba3a.zip
Adding upstream version 060+5.upstream/060+5
Signed-off-by: Daniel Baumann <daniel.baumann@progress-linux.org>
Diffstat (limited to 'modules.d/95dasd_rules/module-setup.sh')
-rwxr-xr-xmodules.d/95dasd_rules/module-setup.sh65
1 files changed, 65 insertions, 0 deletions
diff --git a/modules.d/95dasd_rules/module-setup.sh b/modules.d/95dasd_rules/module-setup.sh
new file mode 100755
index 0000000..06c57a4
--- /dev/null
+++ b/modules.d/95dasd_rules/module-setup.sh
@@ -0,0 +1,65 @@
+#!/bin/bash
+
+# called by dracut
+cmdline() {
+ is_dasd() {
+ local _dev=$1
+ local _devpath
+ _devpath=$(
+ cd -P /sys/dev/block/"$_dev" || exit
+ echo "$PWD"
+ )
+
+ [ "${_devpath#*/dasd}" == "$_devpath" ] && return 1
+ _ccw="${_devpath%%/block/*}"
+ echo "rd.dasd=${_ccw##*/}"
+ return 0
+ }
+ [[ $hostonly ]] || [[ $mount_needs ]] && {
+ for_each_host_dev_and_slaves_all is_dasd || return 255
+ } | sort | uniq
+}
+
+# called by dracut
+check() {
+ local _arch=${DRACUT_ARCH:-$(uname -m)}
+ local found=0
+ local bdev
+ [ "$_arch" = "s390" -o "$_arch" = "s390x" ] || return 1
+
+ [[ $hostonly ]] || [[ $mount_needs ]] && {
+ for bdev in /sys/block/*; do
+ case "${bdev##*/}" in
+ dasd*)
+ found=$((found + 1))
+ break
+ ;;
+ esac
+ done
+ [ $found -eq 0 ] && return 255
+ }
+ return 0
+}
+
+# called by dracut
+depends() {
+ echo 'dasd_mod' bash
+ return 0
+}
+
+# called by dracut
+install() {
+ inst_hook cmdline 30 "$moddir/parse-dasd.sh"
+ if [[ $hostonly_cmdline == "yes" ]]; then
+ local _dasd
+ _dasd=$(cmdline)
+ [[ $_dasd ]] && printf "%s\n" "$_dasd" >> "${initdir}/etc/cmdline.d/95dasd.conf"
+ fi
+ if [[ $hostonly ]]; then
+ inst_rules_wildcard "51-dasd-*.rules"
+ inst_rules_wildcard "41-dasd-*.rules"
+ mark_hostonly /etc/udev/rules.d/51-dasd-*.rules
+ mark_hostonly /etc/udev/rules.d/41-dasd-*.rules
+ fi
+ inst_rules 59-dasd.rules
+}